# 3D Bubble tracking

The present repository contains the code for 3D tracking of bubbles in multi-view measurements as described in

- H. Hessenkemper, L. Wang, D. Lucas. S. Tan, R. Ni and T. Ma 
**3D detection and tracking of deformable bubbles in swarms with the aid of deep learning models.** *submitted to International Journal of Multiphase Flows*

It requires bubble detections generated with our [*bubble detector*](https://doi.org/10.14278/rodare.2566).

## Installation

The code is compatible with python version 3.8. Please install the required packages using 

> pip install -r requirements.txt


## Usage

After installation the demonstration Tracking3D_demo.ipynb notebook can be used to track bubbles in 3D and evaluate the tracking performance with data that has approriate ground truth data.

If you have any questions, please contact h.hessenkemper@hzdr.de
