import numpy as np

def World_to_Image(p,calib):
    """_summary_

    Args:
        p (_type_): x,y,z world coordinates
        calib (dict): camera calibration

    Returns:
        _type_: x and y coordinates in 2D image
    """
    #proj=np.dot(p,calib['R'].T)+calib['T'].T
    proj=np.tensordot(p,calib['R'].T,axes=([0],[0]))+calib['T'].T
    proj=proj.T
    p2=proj*(calib['f_eff']/proj[2])
    #ru2=p2[0]**2+p2[1]**2
    #dummy=1+calib['k1']*ru2
    #p2=p2/dummy
    p2[0]=p2[0]/calib['wpix']+calib['Npixw']/2 
    p2[1]=calib['Npixh']/2-p2[1]/calib['hpix'] 
    return p2
def Image_to_World(p2d,calib:dict):
    """_summary_

    Args:
        p2d (numpy array): x and y coordinates in 2D image
        calib (dict): camera calibration

    Returns:
        _type_: x,y,z world coordinates
    """
    p2=np.copy(p2d)
    p2[:,0]=(p2d[:,0]-calib['Npixw']/2)*calib['wpix']
    p2[:,1]=(calib['Npixh']/2-p2d[:,1])*calib['hpix'] 
    tmp=p2*(calib['T'][2]/calib['f_eff'])
    proj=np.ones((3,len(tmp)))
    proj[0,:]=tmp[:,0]
    proj[1,:]=tmp[:,1]
    proj[2,:]=proj[2,:]*calib['T'][2]
    b=np.dot(calib['Rinv'],(proj-calib['T']))
    #b=np.dot(calib['Rinv'],np.expand_dims((proj-calib['T'].T),axis=-1))
    return b

def transform_calib(calib):
    py_calib={}
    params=['Noffh','Noffw','R','T','Rinv','Tinv','f_eff','hpix','wpix','Npixh','Npixw']
    for i in range(len(calib['camParaCalib'])):
        py_calib['Cam'+str(i+1)]={} 
        for j in range(len(params)):
            py_calib['Cam'+str(i+1)][params[j]]=calib['camParaCalib'][i][0][j] 
    return py_calib