from calibration import *
import numpy as np
import copy

def get_m_c(particle0on1,center0on1):
    m=(center0on1[1]-particle0on1[1])/(center0on1[0]-particle0on1[0])
    c=particle0on1[1]-m*particle0on1[0]
    return m,c

def match_between_view(center0on1,Bubbles0,Bubbles1,max_dist,py_calib1,py_calib2,min_grad=50):
    bubble_matches={} 
    prev_match=[] 
    for j in range(len(Bubbles0)):
        if Bubbles0[j].grad>min_grad:   
            bubble_matches[j]={'matches':[],'dists':[],'unique_match':False}    
            r=Bubbles0[j].ConvertToRDC()
            points=r.points[:,:2].copy()
            points_hi_lo=points[[np.argmax(points[:,0]),np.argmin(points[:,0])],:] 
            points_hi_lo[:,[1,0]]=points_hi_lo[:,[0,1]]       
            p=Image_to_World(np.array(points_hi_lo,dtype=float),py_calib1)
            a=World_to_Image(p,py_calib2)
            particle0on1=a[:,0] 
            center0on1=np.reshape(center0on1,3)
            m,c=get_m_c(particle0on1,center0on1)
            m2,c2=get_m_c(a[:,1],center0on1)
            for b in range(len(Bubbles1)):
                points2=Bubbles1[b].ConvertToRDC().points[:,:2].copy()
                points2_hi_lo=points2[[np.argmax(points2[:,0]),np.argmin(points2[:,0])],:] 
                dist=abs(m*points2_hi_lo[0,1]-points2_hi_lo[0,0]+c)/np.sqrt(m**2+1)
                dist2=abs(m2*points2_hi_lo[1,1]-points2_hi_lo[1,0]+c2)/np.sqrt(m2**2+1)
                if dist2<max_dist and dist<max_dist:               
                    bubble_matches[j]['matches'].append(b)
                    bubble_matches[j]['dists'].append((dist,dist2))  
                    #bubble_matches[j]['hi_lo'].append((points_hi_lo,points2_hi_lo)) 
                    if b not in prev_match:
                        bubble_matches[j]['unique_match']=True 
                    else:
                        for key in bubble_matches.keys():
                            if key!=j and b in bubble_matches[key]['matches']:
                                bubble_matches[key]['unique_match']=False
                    prev_match.append(b)
            if len(bubble_matches[j]['matches'])==0:
                bubble_matches.pop(j)
            elif len(bubble_matches[j]['matches'])>1:
                bubble_matches[j]['unique_match']=False
    unique_matched=[]
    unique_counter=[] 
    for key in bubble_matches.keys():
        if bubble_matches[key]['unique_match']==True:
            unique_matched.append(key)  
            unique_counter.append(bubble_matches[key]['matches'][0])
    return bubble_matches,unique_matched,unique_counter

def find_unique_forth_back(bubble_matches,cams):
    all_unique={'Cam'+str(c+1):{} for c in range(4)}  
    for i in range(cams):
        for j in range(cams):
            if i!=j:
                match_set=set(bubble_matches['Cam'+str(i+1)+'on'+'Cam'+str(j+1)]['unique_matches']).intersection(bubble_matches['Cam'+str(j+1)+'on'+'Cam'+str(i+1)]['unique_counter'])
                all_unique['Cam'+str(i+1)]['Cam'+str(i+1)+'on'+'Cam'+str(j+1)]={} 
                all_unique['Cam'+str(i+1)]['Cam'+str(i+1)+'on'+'Cam'+str(j+1)]['match']=match_set 
                match_counter=[]
                for id in match_set:
                    idx=np.argwhere(np.array(bubble_matches['Cam'+str(i+1)+'on'+'Cam'+str(j+1)]['unique_matches'])==id)
                    match_counter.append(bubble_matches['Cam'+str(i+1)+'on'+'Cam'+str(j+1)]['unique_counter'][idx[0][0]]) 
                all_unique['Cam'+str(i+1)]['Cam'+str(i+1)+'on'+'Cam'+str(j+1)]['counter']=match_counter 
    return all_unique

def get_candidates(all_unique_org,bubble_matches,num_cams):
    all_unique=copy.deepcopy(all_unique_org)
    reduce={'Cam'+str(c+1):[] for c in range(num_cams)}  
    
    candidates={} 
    for key in all_unique.keys():
        keys2=list(all_unique[key].keys())
        #all_unique[key]['already_matched']=[] 
        if len(reduce[key])>0:
            for r in reduce[key]:
                if r in all_unique[key][keys2[0]]['match']:
                    idx=np.argwhere(np.array(list(all_unique[key][keys2[0]]['match']))==r)
                    del all_unique[key][keys2[0]]['counter'][idx[0][0]] 
                    #all_unique[key]['already_matched'].append(r)
                    all_unique[key][keys2[0]]['match'].remove(r)
                if r in all_unique[key][keys2[1]]['match']:
                    idx=np.argwhere(np.array(list(all_unique[key][keys2[1]]['match']))==r)
                    del all_unique[key][keys2[1]]['counter'][idx[0][0]] 
                    #all_unique[key]['already_matched'].append(r)
                    all_unique[key][keys2[1]]['match'].remove(r)
                if r in all_unique[key][keys2[2]]['match']:
                    idx=np.argwhere(np.array(list(all_unique[key][keys2[2]]['match']))==r)
                    del all_unique[key][keys2[2]]['counter'][idx[0][0]] 
                    #all_unique[key]['already_matched'].append(r)
                    all_unique[key][keys2[2]]['match'].remove(r)
        m0102=set(all_unique[key][keys2[0]]['match']).intersection(all_unique[key][keys2[1]]['match'])
        m0103=set(all_unique[key][keys2[0]]['match']).intersection(all_unique[key][keys2[2]]['match'])
        m0203=set(all_unique[key][keys2[1]]['match']).intersection(all_unique[key][keys2[2]]['match'])
        min_three=m0102.union(m0103).union(m0203)
        candidates[key]={} 
        reduced={'Cam'+str(c+1):[] for c in range(num_cams)}  
        for id in min_three:
            candidates[key][id]={}  
            if id in m0102:               
                idx=np.argwhere(np.array(bubble_matches[keys2[0]]['unique_matches'])==id)            
                if bubble_matches[keys2[0]]['unique_counter'][idx[0][0]] not in reduce[keys2[0][6:]]:
                    candidates[key][id][keys2[0][6:]]=bubble_matches[keys2[0]]['unique_counter'][idx[0][0]]
                    reduce[keys2[0][6:]].append(bubble_matches[keys2[0]]['unique_counter'][idx[0][0]])
                else:
                    reduced[keys2[0][6:]].append(bubble_matches[keys2[0]]['unique_counter'][idx[0][0]])
                idx=np.argwhere(np.array(bubble_matches[keys2[1]]['unique_matches'])==id)
                if bubble_matches[keys2[1]]['unique_counter'][idx[0][0]] not in reduce[keys2[1][6:]]:
                    candidates[key][id][keys2[1][6:]]=bubble_matches[keys2[1]]['unique_counter'][idx[0][0]]
                    reduce[keys2[1][6:]].append(bubble_matches[keys2[1]]['unique_counter'][idx[0][0]])
                else:
                    reduced[keys2[1][6:]].append(bubble_matches[keys2[1]]['unique_counter'][idx[0][0]])
            if id in m0103:
                idx=np.argwhere(np.array(bubble_matches[keys2[0]]['unique_matches'])==id)              
                if bubble_matches[keys2[0]]['unique_counter'][idx[0][0]] not in reduce[keys2[0][6:]]:
                    candidates[key][id][keys2[0][6:]]=bubble_matches[keys2[0]]['unique_counter'][idx[0][0]]
                    reduce[keys2[0][6:]].append(bubble_matches[keys2[0]]['unique_counter'][idx[0][0]])
                else:
                    reduced[keys2[0][6:]].append(bubble_matches[keys2[0]]['unique_counter'][idx[0][0]])
                idx=np.argwhere(np.array(bubble_matches[keys2[2]]['unique_matches'])==id)
                if bubble_matches[keys2[2]]['unique_counter'][idx[0][0]] not in reduce[keys2[2][6:]]:
                    candidates[key][id][keys2[2][6:]]=bubble_matches[keys2[2]]['unique_counter'][idx[0][0]]
                    reduce[keys2[2][6:]].append(bubble_matches[keys2[2]]['unique_counter'][idx[0][0]])
                else:
                    reduced[keys2[2][6:]].append(bubble_matches[keys2[2]]['unique_counter'][idx[0][0]])
            if id in m0203:
                idx=np.argwhere(np.array(bubble_matches[keys2[1]]['unique_matches'])==id)
                if bubble_matches[keys2[1]]['unique_counter'][idx[0][0]] not in reduce[keys2[1][6:]]:
                    candidates[key][id][keys2[1][6:]]=bubble_matches[keys2[1]]['unique_counter'][idx[0][0]]
                    reduce[keys2[1][6:]].append(bubble_matches[keys2[1]]['unique_counter'][idx[0][0]])
                else:
                    reduced[keys2[1][6:]].append(bubble_matches[keys2[1]]['unique_counter'][idx[0][0]])
                idx=np.argwhere(np.array(bubble_matches[keys2[2]]['unique_matches'])==id)
                if bubble_matches[keys2[2]]['unique_counter'][idx[0][0]] not in reduce[keys2[2][6:]]:
                    candidates[key][id][keys2[2][6:]]=bubble_matches[keys2[2]]['unique_counter'][idx[0][0]]
                    reduce[keys2[2][6:]].append(bubble_matches[keys2[2]]['unique_counter'][idx[0][0]])
                else:
                    reduced[keys2[2][6:]].append(bubble_matches[keys2[2]]['unique_counter'][idx[0][0]])
            if len(list(candidates[key][id].keys()))<2 and len(list(candidates[key][id].keys()))>0:
                candidates[key].pop(id)
    
    for cam in candidates.keys():
        to_remove=[] 
        for id in candidates[cam].keys():
            if len(list(candidates[cam][id].keys()))==0:
                to_remove.append(id)
        for id in to_remove:
            candidates[cam].pop(id)
    return candidates

def create_tmp(sight):
    tmp=np.array([[1-sight[0]**2,-sight[0]*sight[1],-sight[0]*sight[2]],
                  [-sight[1]*sight[0],1-sight[1]**2,-sight[1]*sight[2]],
                [-sight[2]*sight[0],-sight[2]*sight[1],1-sight[2]**2]]).reshape(3,3)
    return tmp

def triangulate(candidates,All_Bubbles,py_calib,num_cams):
    triangul_pos=[] 
    to_remove={'Cam'+str(c+1):[] for c in range(num_cams)}  
    triang_id={'Cam'+str(c+1):[] for c in range(num_cams)}  
    bub_props={'size':{'Cam'+str(c+1):[] for c in range(num_cams)},'aspect':{'Cam'+str(c+1):[] for c in range(num_cams)}}  
    for cam in candidates.keys():
        if len(candidates[cam])>0: 
            for id in candidates[cam]:
                P=np.zeros(3)
                M=np.zeros((3,3))
                center1=All_Bubbles[cam][id].Position
                sight=Image_to_World(np.array([center1[1],center1[0]],dtype=float).reshape((1,2)),py_calib[cam])-py_calib[cam]['Tinv']
                sight/=np.linalg.norm(sight)
                tmp=create_tmp(sight)
                P+=(np.dot(tmp,py_calib[cam]['Tinv'].reshape(3)))
                M+=tmp
                for cam2 in candidates[cam][id].keys():
                    idx=candidates[cam][id][cam2] 
                    center=All_Bubbles[cam2][idx].Position
                    sight=Image_to_World(np.array([center[1],center[0]],dtype=float).reshape((1,2)),py_calib[cam2])-py_calib[cam2]['Tinv']
                    sight/=np.linalg.norm(sight)
                    tmp=create_tmp(sight)
                    P+=(np.dot(tmp,py_calib[cam2]['Tinv'].reshape(3)))
                    M+=tmp
                worldpos=np.dot(np.linalg.inv(M),P)
                #Reproject
                pos_im=World_to_Image(worldpos.reshape(3),py_calib[cam])
                dist=np.sqrt((pos_im[0]-center1[1])**2+(pos_im[1]-center1[0])**2)
                if dist>100:
                    continue
                else:
                    to_remove[cam].append(id)
                    triang_id[cam].append(All_Bubbles[cam][id].ID) 
                    if isinstance(All_Bubbles[cam][id].Diameter,float):
                        bub_props['size'][cam].append(All_Bubbles[cam][id].Diameter) 
                        bub_props['aspect'][cam].append(All_Bubbles[cam][id].Minor/All_Bubbles[cam][id].Major)
                    else:
                        bub_props['size'][cam].append(All_Bubbles[cam][id].Diameter.flatten()[0]) 
                        bub_props['aspect'][cam].append(All_Bubbles[cam][id].Minor.flatten()[0]/All_Bubbles[cam][id].Major.flatten()[0])
                    for cam2 in candidates[cam][id].keys():
                        idx=candidates[cam][id][cam2]
                        to_remove[cam2].append(idx) 
                        triang_id[cam2].append(All_Bubbles[cam2][idx].ID) 
                        if isinstance(All_Bubbles[cam2][idx].Diameter,float):
                            bub_props['size'][cam2].append(All_Bubbles[cam2][idx].Diameter) 
                            bub_props['aspect'][cam2].append(All_Bubbles[cam2][idx].Minor/All_Bubbles[cam2][idx].Major)
                        else:
                            bub_props['size'][cam2].append(All_Bubbles[cam2][idx].Diameter.flatten()[0]) 
                            bub_props['aspect'][cam2].append(All_Bubbles[cam2][idx].Minor.flatten()[0]/All_Bubbles[cam2][idx].Major.flatten()[0])
                    for c in triang_id.keys():
                        if c not in candidates[cam][id].keys() and c!=cam:
                            triang_id[c].append(-1) 
                            bub_props['size'][c].append(-1)
                            bub_props['aspect'][c].append(-1)  
                triangul_pos.append(worldpos)
    for cam in to_remove.keys():
        for id in reversed(sorted(to_remove[cam])):         
            del All_Bubbles[cam][id]
    return triangul_pos,bub_props,triang_id

        
def draw_project_line(bubble,py_calib1,py_calib2,im1,im2,center0on1,ax1,ax2,matched_bubble=None):
    random_color=tuple((np.random.choice(range(255),size=3))/255.0)
    ax1.imshow(im1,cmap='gray')
    ax2.imshow(im2,cmap='gray')
    r=bubble.ConvertToRDC()
    r.drawRD(ax=ax1,color=random_color,linewidths=0.5)
    if matched_bubble is not None:
        rr=matched_bubble.ConvertToRDC()
        rr.drawRD(ax=ax2,color='r',linewidths=0.5)
    points=r.points[:,:2].copy()
    points_hi_lo=points[[np.argmax(points[:,0]),np.argmin(points[:,0])],:] 
    ax1.scatter(points_hi_lo[:,1],points_hi_lo[:,0],color='g')
    points_hi_lo[:,[1,0]]=points_hi_lo[:,[0,1]]       
    p=Image_to_World(np.array(points_hi_lo,dtype=float),py_calib1)
    a=World_to_Image(p,py_calib2)
    particle0on1=a[:,0] 
    center0on1=np.reshape(center0on1,3)
    m,c=get_m_c(particle0on1,center0on1)
    m2,c2=get_m_c(a[:,1],center0on1)
    p1=[0,c]
    p2=[py_calib2['Npixw'],m*py_calib2['Npixw']+c] 
    ax2.plot([p1[0],p2[0]],[p1[1],p2[1]],color='g')
    p1=[0,c2]
    p2=[py_calib2['Npixw'],m2*py_calib2['Npixw']+c2] 
    ax2.plot([p1[0],p2[0]],[p1[1],p2[1]],color='g')

def get_projected_line(points,py_calib1,py_calib2):
    p=Image_to_World(np.array(points,dtype=float),py_calib1)
    a=World_to_Image(p,py_calib2)
    center0on1=World_to_Image(py_calib1['Tinv'].reshape(3),py_calib2)
    center0on1=np.reshape(center0on1,3)
    m1,c1=get_m_c(a[:,0],center0on1)
    m2,c2=get_m_c(a[:,1],center0on1)
    return m1,c1,m2,c2

